# Создание скрытых символических ссылок в пользовательских папках для препятствия их переносу в OneDrive
# Запускать  от имени администратора
# https://www.outsidethebox.ms/21844

param(
    [string[]]$folders
    )
# проверка прав
if (-Not ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] 'Administrator')) {
    Write-Host "Insufficient privileges. Run this script as administrator." -ForegroundColor 'red'
  Exit
}
# создание ссылок в текущем аккаунте
if (!$folders) {
    $folders = @('Desktop', 'MyDocuments', 'MyPictures', 'MyMusic', 'MyVideos')
    foreach ($folder in $folders) {
        # путь для ссылки с учетом определения пользовательских папок https://t.me/sterkin_ru/1372
        $link = Join-Path -Path $([Environment]::GetFolderPath("$folder")) -ChildPath "\calc.exe"
        # создание символической ссылки на калькулятор
        New-Item -ItemType SymbolicLink -Path $link -Target "C:\Windows\System32\calc.exe" 
        # скрытие ссылки путем назначения атрибутов "Скрытый" и "Системный" https://t.me/sterkin_ru/1359
        Get-ChildItem -Path $link | ForEach-Object {$_.Attributes += 'Hidden'; $_.Attributes += 'System'}
    }
}
# создание ссылок в любых аккаунтах 
# пути к папкам передаются скрипту параметром -folders
# .\create-symlinks.ps1 -folders 'C:\Users\Username\Desktop', 'C:\Users\Username\Pictures'
else {
    foreach ($folder in $folders) {
        $link = Join-Path -Path $folder -ChildPath "\calc.exe"
        New-Item -ItemType SymbolicLink -Path $link -Target "C:\Windows\System32\calc.exe" 
        Get-ChildItem -Path $link | ForEach-Object {$_.Attributes += 'Hidden'; $_.Attributes += 'System'}
    }
}
<# 
# удаление созданных ссылок (пример для текущего аккаунта)
$folders = @('Desktop', 'MyDocuments', 'MyPictures', 'MyMusic', 'MyVideos')
foreach ($folder in $folders) {
    $link = Join-Path -Path $([Environment]::GetFolderPath("$folder")) -ChildPath "\calc.exe"
    Remove-Item -Path $link -Force
}
 #>
